private import  mango.text.LineToken;

private import  mango.io.Console,
                mango.io.FileConduit,
                mango.io.BufferTokenizer;

/*******************************************************************************

        Read a file line-by-line, sending each one to the console. This
        illustrates how BufferTokenizer can be used to bind a Conduit or 
        a Buffer to a Token.

        Note that both Token and BufferTokenizer are templated for char, 
        wchar and dchar ~ this example uses char

*******************************************************************************/

void main (char[][] args)
{
	if (args.length == 2)
	   {
           // open a file for reading
           auto file = new FileConduit (args[1]);

           // create a Token and bind it to the file
           auto lines = new BufferTokenizer (file, new LineToken);

           // read file a line at a time
           foreach (char[] line; lines)
                    Cout (line) ("\n");
           }
        else
           Cout ("usage: lineio filename");
}

